﻿using System;
using System.ComponentModel;
using System.Runtime.InteropServices;
using AddinExpress.MSO;
using Microsoft.Office.Interop.Excel;
using Application = System.Windows.Forms.Application;
using Excel = Microsoft.Office.Interop.Excel;
using System.Windows.Forms;

namespace ExcelColRow
{
    /// <summary>
    ///     Add-in Express Add-in Module
    /// </summary>
    [Guid("A659AE50-9842-40CB-83F4-E06F232251CD"), ProgId("ExcelColRow.AddinModule")]
    public class AddinModule : ADXAddinModule
    {
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonButton columnLetterRibbonButton;
        private ADXRibbonButton getColumnIndexRibbonButton;

        #region Component Designer generated code

        /// <summary>
        ///     Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        ///     Required by designer support - do not modify
        ///     the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.columnLetterRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.getColumnIndexRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Excel Row Letters C#";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_a381fab4c1014ebdb673010af26b4fca";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "C#";
            this.adxRibbonGroup1.Controls.Add(this.columnLetterRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.getColumnIndexRibbonButton);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_cde738eb99f249a3baec6b5bc890566f";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            // 
            // columnLetterRibbonButton
            // 
            this.columnLetterRibbonButton.Caption = "Get Column Letter";
            this.columnLetterRibbonButton.Id = "adxRibbonButton_414bc9843e6d41ddbbba03b087ea81f0";
            this.columnLetterRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.columnLetterRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.columnLetterRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.columnLetterRibbonButton_OnClick);
            // 
            // getColumnIndexRibbonButton
            // 
            this.getColumnIndexRibbonButton.Caption = "Get Column Index";
            this.getColumnIndexRibbonButton.Id = "adxRibbonButton_184f2f4a6fad4701ae4dba400cd8a4d6";
            this.getColumnIndexRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.getColumnIndexRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.getColumnIndexRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.getColumnIndexRibbonButton_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "ExcelColRow";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;

        }

        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override IContainer GetContainer()
        {
            if (components == null)
                components = new Container();
            return components;
        }

        [ComRegisterFunction]
        public static void AddinRegister(Type t)
        {
            ADXRegister(t);
        }

        [ComUnregisterFunction]
        public static void AddinUnregister(Type t)
        {
            ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        public new static AddinModule CurrentInstance
        {
            get { return ADXAddinModule.CurrentInstance as AddinModule; }
        }

        public _Application ExcelApp
        {
            get { return (HostApplication as _Application); }
        }

        private void adxRibbonButton1_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Worksheet sheet = null;
            Range range = null;
            Range relativeRange = null;
            Range offsetRange = null;

            try
            {
                sheet = (Worksheet)ExcelApp.ActiveSheet;
                range = sheet.Cells[2, 1] as Excel.Range;
                relativeRange = sheet.Cells[1, 1] as Excel.Range;

                string address = range.Address[false, false, XlReferenceStyle.xlR1C1, Type.Missing, relativeRange];
                int col = range.Column;
                int row = range.Row;

                //range.Value = address; //+ " - " + col + " / " + row;
                range.Formula = "=SUBSTITUTE(TEXT(ADDRESS(1,10,4),\"\"),\"1\",\"\")";
                relativeRange.Value = "relative";
                //offsetRange = range.Offset[1, 0];
                //offsetRange.Value = "Offset";
            }
            finally
            {
                if (offsetRange != null) Marshal.ReleaseComObject(offsetRange);
                if (range != null) Marshal.ReleaseComObject(range);
                if (sheet != null) Marshal.ReleaseComObject(sheet);
                if (relativeRange != null) Marshal.ReleaseComObject(relativeRange);
            }
        }

        private string GetExcelColumnName(int columnNumber)
        {
            int dividend = columnNumber;
            string columnName = String.Empty;
            int modulo;

            while (dividend > 0)
            {
                modulo = (dividend - 1) % 26;
                columnName = Convert.ToChar(65 + modulo) + columnName;
                dividend = (dividend - modulo) / 26;
            }
            return columnName;
        }

        private void columnLetterRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Worksheet sheet = null;
            Range range = null;
            string colLetter = string.Empty;

            try
            {
                sheet = (Worksheet)ExcelApp.ActiveSheet;
                range = sheet.Cells[1, 50] as Excel.Range;
                colLetter = range.Address[false, false, XlReferenceStyle.xlA1];
                colLetter = colLetter.Replace("1", "");
                MessageBox.Show(String.Format("Column letter for column number 50 is : {0}", colLetter));
            }
            finally
            {
                if (sheet != null) Marshal.ReleaseComObject(sheet);
                if (range != null) Marshal.ReleaseComObject(range);
            }
        }

        private void getColumnIndexRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Worksheet sheet = null;
            Range range = null;
            int colIndex = 0;

            try
            {
                sheet = (Worksheet)ExcelApp.ActiveSheet;
                range = sheet.Range["ADX1"] as Excel.Range;
                colIndex = range.Column;
                MessageBox.Show(String.Format("Column index for column letter ADX is : {0}", colIndex));
            }
            finally
            {
                if (sheet != null) Marshal.ReleaseComObject(sheet);
                if (range != null) Marshal.ReleaseComObject(range);
            }
        }
    }
}