﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Excel = Microsoft.Office.Interop.Excel

'Add-in Express Add-in Module
<GuidAttribute("DF880965-9A81-45E1-9BED-7C8EF8DF6A34"), ProgIdAttribute("ExcelColRowVB.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents AdxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents GetColumnLetterRibbonGroup As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents GetColumnLetterRibbonButton As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents GetColumnIndexRibbonButton As AddinExpress.MSO.ADXRibbonButton

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.AdxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.GetColumnLetterRibbonGroup = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.GetColumnLetterRibbonButton = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.GetColumnIndexRibbonButton = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        '
        'AdxRibbonTab1
        '
        Me.AdxRibbonTab1.Caption = "Excel Row Letters VB"
        Me.AdxRibbonTab1.Controls.Add(Me.GetColumnLetterRibbonGroup)
        Me.AdxRibbonTab1.Id = "adxRibbonTab_ff9bc8150dd6497b90b73fc4fd540ba0"
        Me.AdxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'GetColumnLetterRibbonGroup
        '
        Me.GetColumnLetterRibbonGroup.Caption = "VB"
        Me.GetColumnLetterRibbonGroup.Controls.Add(Me.GetColumnLetterRibbonButton)
        Me.GetColumnLetterRibbonGroup.Controls.Add(Me.GetColumnIndexRibbonButton)
        Me.GetColumnLetterRibbonGroup.Id = "adxRibbonGroup_54e0ec989038474f910187c0b00c13dc"
        Me.GetColumnLetterRibbonGroup.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.GetColumnLetterRibbonGroup.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'GetColumnLetterRibbonButton
        '
        Me.GetColumnLetterRibbonButton.Caption = "Get Column Letter"
        Me.GetColumnLetterRibbonButton.Id = "adxRibbonButton_2963fd066e0143b19d902d21cb9a826b"
        Me.GetColumnLetterRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.GetColumnLetterRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'GetColumnIndexRibbonButton
        '
        Me.GetColumnIndexRibbonButton.Caption = "Get Column Index"
        Me.GetColumnIndexRibbonButton.Id = "adxRibbonButton_e474ee3542af481d916ed275e1973db4"
        Me.GetColumnIndexRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.GetColumnIndexRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AddinModule
        '
        Me.AddinName = "ExcelColRowVB"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property ExcelApp() As Excel._Application
        Get
            Return CType(HostApplication, Excel._Application)
        End Get
    End Property

    Private Sub GetColumnLetterRibbonButton_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles GetColumnLetterRibbonButton.OnClick
        Dim sheet As Excel.Worksheet = Nothing
        Dim range As Excel.Range = Nothing
        Dim colLetter As String = String.Empty

        Try
            sheet = DirectCast(ExcelApp.ActiveSheet, Excel.Worksheet)
            range = TryCast(sheet.Cells(1, 50), Excel.Range)
            colLetter = range.Address(False, False, Excel.XlReferenceStyle.xlA1)
            colLetter = colLetter.Replace("1", "")
            MessageBox.Show(String.Format("Column letter for column number 50 is : {0}", colLetter))
        Finally
            If sheet IsNot Nothing Then
                Marshal.ReleaseComObject(sheet)
            End If
            If range IsNot Nothing Then
                Marshal.ReleaseComObject(range)
            End If
        End Try
    End Sub

    Private Sub GetColumnIndexRibbonButton_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles GetColumnIndexRibbonButton.OnClick
        Dim sheet As Excel.Worksheet = Nothing
        Dim range As Excel.Range = Nothing
        Dim colIndex As Integer = 0

        Try
            sheet = DirectCast(ExcelApp.ActiveSheet, Excel.Worksheet)
            range = TryCast(sheet.Range("ADX1"), Excel.Range)
            colIndex = range.Column
            MessageBox.Show([String].Format("Column index for column letter ADX is : {0}", colIndex))
        Finally
            If sheet IsNot Nothing Then
                Marshal.ReleaseComObject(sheet)
            End If
            If range IsNot Nothing Then
                Marshal.ReleaseComObject(range)
            End If
        End Try
    End Sub
End Class

